import * as VScript from "vscript";
import * as VAPI from "./index.js";
export declare const lift: {
    readonly BytesCounter: (_raw: [number, number], _socket: VScript.VSocket) => BytesCounter;
    readonly Counter: (_raw: [number, number, number, number], _socket: VScript.VSocket) => Counter;
    readonly EventsCounter: (_raw: [number, number], _socket: VScript.VSocket) => EventsCounter;
    readonly PacketsCounter: (_raw: [number, number], _socket: VScript.VSocket) => PacketsCounter;
};
export declare const lower: {
    readonly BytesCounter: (_x: {
        bytes_total: VAPI.Primitives.Unsigned64;
        bytes_per_sec: VAPI.Primitives.Unsigned64;
    }, _socket: VScript.VSocket) => [number, number];
    readonly Counter: (_x: {
        bytes_total: VAPI.Primitives.Unsigned64;
        packets_total: VAPI.Primitives.Unsigned64;
        bytes_per_sec: VAPI.Primitives.Unsigned64;
        packets_per_sec: VAPI.Primitives.Unsigned32;
    }, _socket: VScript.VSocket) => [number, number, number, number];
    readonly EventsCounter: (_x: {
        events_total: VAPI.Primitives.Unsigned64;
        events_per_sec: VAPI.Primitives.Unsigned32;
    }, _socket: VScript.VSocket) => [number, number];
    readonly PacketsCounter: (_x: {
        packets_total: VAPI.Primitives.Unsigned64;
        packets_per_sec: VAPI.Primitives.Unsigned32;
    }, _socket: VScript.VSocket) => [number, number];
};
export interface BytesCounter {
    bytes_total: VAPI.Primitives.Unsigned64;
    bytes_per_sec: VAPI.Primitives.Unsigned64;
}
export interface Counter {
    bytes_total: VAPI.Primitives.Unsigned64;
    packets_total: VAPI.Primitives.Unsigned64;
    bytes_per_sec: VAPI.Primitives.Unsigned64;
    packets_per_sec: VAPI.Primitives.Unsigned32;
}
export interface EventsCounter {
    events_total: VAPI.Primitives.Unsigned64;
    events_per_sec: VAPI.Primitives.Unsigned32;
}
export interface PacketsCounter {
    packets_total: VAPI.Primitives.Unsigned64;
    packets_per_sec: VAPI.Primitives.Unsigned32;
}
